Program ZipList;



{*****************************************************************************

                 Example program for use with ZIPPER.PAS.

  NOTE: Most of the Zipper routines were written with pointers in mind,
        assuming that a program would want to process ZIP entryies via
        linked lists (or some other dynamic data structure). In this
        test code, you notice that I used a static data structure (Zrec)
        and passed to other procedures as @Zrec. Sorry for the confusion.


*****************************************************************************}





Uses
  pkPort,pkMisc,pkDoor,Zipper;


Const
  CompMethodStr : Array[0..9] of String = ('No Compression','Shrunk','Reduced (CF=1)',
                                        'Reduced (CF=2)','Reduced (CF=3)','Reduced (CF=5)',
                                        ' ',' ',' ',' ');

Var
  zF        : zFile;
  zFileName : String;
  Zrec      : ZipDirRec;
  d         : Byte;
  Wait      : Boolean;

Function RealInt(R : Real): Integer;
Var
    rr  : String[17];
    rs  : String[17];
    I   : Integer;
    D   : Byte;
  Begin
    Str(r,rr);
    While Pos(' ',rr[1])<>0 do Delete(rr,1,1);
    d:=Pos('.',rr);
    If d<>0 then Delete(rr,d,1);
    rs:=Copy(rr,Length(rr)-1,2);
    val(rs,d,i);
    rs:=Copy(rr,1,d+1);
    Val(rs,d,i);
    If d<>0 then RealInt:=d
            Else RealInt:=0;
  End;


Function Pad(S : String; Len : Byte) : String;
Begin

     While Length(S) < Len Do
        S := S + ' ';

     Pad := S;

End;


Procedure Header;
Begin

     pkLn;
     pkWriteLn('|54     File name       Normal    Compressed    Factor   Compression Method');
     pkWriteLn('|53     -------------------------------------------------------------------');
     pkWrite('|52');
End;

Procedure HeaderEnd;
Begin

     pkWriteLn('|53     -------------------------------------------------------------------');
     pkWriteLn('|54     ZiPLiST v.1.21 (c) Okt. ''95 By MuHaDiB');
     pkLn;

End;

Procedure  ShowFile(pZ : pZipDir);
Var Fact     : Integer;
    FileName : String;
Begin


   With pZ^, pCD^, FileInfo Do
   Begin
     FileName:=pad(MakeFileName(pZ),12);
     For fact:=1 to Length(Filename) do If FileName[fact]='/' then FileName[fact]:='\';
     While pos('\',FileName)>0 do Delete(FileName,1,pos('\',FileName));
     If FileName<>'' Then Begin
       For fact:=1 to 12-Length(FileName) do FileName:=FileName+' ';
       pkWrite('     '+Filename+pkIntStr(UnCompSize,10)+pkIntStr(CompSize,12));
       If UnCompSize<>0 then Begin
         Fact:=RealInt(100-((CompSize/UnCompSize)*100));
         pkWrite(pkIntStr(Fact,10)+'%');
       End
       Else pkWrite('         0%');
       pkWriteLn('        '+CompMethodStr[CompMethod]);
     End;
   End;

End;

Function EnterLine(show : String;keys : Byte) : String;
Var
  Line                    : String;
  k                       : Byte;
  Continue                : Boolean;
  ch                      : Char;

  Begin
    k:=0;
    Line:='';
    Continue:=True;
    pkWrite(show);
    Repeat
      ch:=pkReadKey;
      If (ch in [#1..#7,#9..#12,#14..#26,#28..#255]) and (length(Line) < keys) then Begin
        pkwrite(ch);
        K:=K+1;
        Line:=Line+ch;
      End;
        If (ch=#13) or (ch=#27) then continue:=false
        Else if ch=#8 then Begin
          delete(Line,length(Line),1);
          if K > 0 then pkWrite(#8+#32+#8);
          if K > 0 then K:=K-1;
        End;
        If k>=keys then k:=keys;
    Until (continue=false) ;
    EnterLine:=Line;
  End;



Begin
        If pkLocal then Begin
          pkCheckCd:=False;
          pkAnsi:=True;
        End;
        If ParamCount < 1 Then
        Begin

          Writeln;
          Writeln('  Usage: ZipList -N<NODENUMBER> [-<FILENAME.ZIP>] [-WAIT]');
          Halt;

        End;
        Wait:=False;
        zFileName:='';
        For d :=1 to ParamCount do If pkUpper(ParamStr(d))='-WAIT' then Wait:=True;
        zFileName:=pkUpper(pkDrop.Parameters);

        If zFileName='' then Begin
          For d:=1 to ParamCount do If Pos('.ZIP',pkUpper(ParamStr(d)))<>0 then Begin
            zFileName:=Copy(pkUpper(ParamStr(d)),2,255);
            d:=ParamCount;
          End;
        End;
        If zFileName<>'' then Begin
          pkReadConf(pkDrop.CurrentConf);
          For d:=1 to 9 do If pkExist(pkConf.ConfFiles[d]+zFileName) Then zFileName:=pkConf.ConfFiles[d]+zFileName;
          If not pkExist(zFileName) then zFileName:='';
        End;
        If (zFileName='-/LOCAL') then zFileName:='';
        If (zFileName[1]='-') then Delete(zFileName,1,1);
        If zFileName='' Then Begin
          pkLn;
          pkLn;
          zFileName:=EnterLine('|52Enter ZiP-Filename|53: |51',59);
          pkLn;
          pkReadConf(pkDrop.CurrentConf);
          For d:=1 to 9 do If pkExist(pkConf.ConfFiles[d]+zFileName) Then zFileName:=pkConf.ConfFiles[d]+zFileName;
          If not pkExist(zFileName) then zFileName:=' ';
        End
        Else If zFileName[1]='-' then Delete(zFileName,1,1);
        If NOT OpenZip(zF,zFileName) then
        Begin
          pkLn;
          pkWriteln('  Unable to open file');
          pkLn;
          If Wait then Begin
            pkWrite('|54(|53Hit any key|54)');
            Repeat Until pkKeyPressed;
            pkReadKey;
            pkLn;
          End;

          Exit;

        End;

        If FindCentralDirectory(zF) <> 0 Then
        Begin

           Header;

           While ReadCentralDirEntry(zF,@ZRec) Do
           Begin

             ShowFile(@Zrec);
             FreeZipRec(@ZRec);

           End;

           HeaderEnd;

        End
        Else
          pkWriteln('  Unable to find ZIP directory.');

        Close(zF);
        If Wait then Begin
          pkWrite('|54(|53Hit any key|54)');
          Repeat Until pkKeyPressed;
          pkReadKey;
          pkLn;
        End;
End.










